package psapplets;

import java.applet.*;
import java.awt.*;
import psplot.*;
import real.*;

class psInteractiveAnimationCanvas extends PlotCanvas implements Runnable {
	Color squareColor = Color.red;
	public psInteractiveAnimationCanvas(Applet app, int w, int h) {
		super(app, w, h);
		double ht = 3;
		// preserve aspect ratio
		double wd = w*(ht/h);
		setCorners(-wd, -ht, wd, ht);
	}

	public void draw() {
		PlotPath p;
		p = new PlotPath(this);
		p.moveto(-0.5, -0.5);
		p.lineto( 0.5, -0.5);
		p.lineto( 0.5,  0.5);
		p.lineto(-0.5, 0.5);
		p.close();
		p.fill(squareColor);
		p.stroke(Color.black);
	}

	boolean ok = true;
	
	public void run() {
		double t = 0.05;
		while (ok) {
			rotate(t);
			// translate(t, t);
			// scale(1+t, 1+t);
			repaint();
			try {
				Thread.sleep(100);
			} catch (InterruptedException ie) { ; }
		}
	}
}

public class psInteractiveAnimationApplet extends Applet {
	psInteractiveAnimationCanvas p;
	Thread th;
	
	public void init() {
		p = new psInteractiveAnimationCanvas(this, bounds().width, bounds().height);
		add(p);
		show();
	}
	
	public void start() {
		th = new Thread(p);
		th.start();
	}

	public void stop() {
		p.ok = false;
	}

	public boolean mouseDown(Event e, int x, int y) {
		p.squareColor = Color.green;
		p.repaint();
		p.ok = false;
		return(true);
	}

	public boolean mouseUp(Event e, int x, int y) {
		p.squareColor = Color.red;
		p.repaint();
		p.ok = true;
		th = new Thread(p);
		th.start();
		return(true);
	}	
}
