package psplot;

import java.applet.*;
import java.awt.*;
import real.*;

class bezAnimationCanvas extends PlotCanvas implements Runnable {
	public bezAnimationCanvas(Applet app, int w, int h) {
		super(app, w, h);
		double ht = 3;
		// preserve aspect ratio
		double wd = w*(ht/h);
		setCorners(-wd, -ht, wd, ht);
	}
	
	public void draw() {
		PlotPath p;
		p = new PlotPath(this);
		p.moveto(-1, 0);
		p.curveto(-1,  1,  1,  1,  1, 0);
		p.curveto( 1, -1, -1, -1, -1, 0);
		p.fill(Color.blue);
		p.stroke(Color.black);
	}
	
	public void run() {
		double t = 0.05;
		while (true) {
			rotate(t);
			// translate(t, t);
			// scale(1+t, 1+t);
			repaint();
			try {
				Thread.sleep(100);
			} catch (InterruptedException ie) { ; }
		}
	}
}

public class bezAnimationApplet extends Applet {
	bezAnimationCanvas p;
	Thread th;
	
	public void init() {
		p = new bezAnimationCanvas(this, bounds().width, bounds().height);
		add(p);
		show();
	}
	
	public void start() {
		th = new Thread(p);
		th.start();
	}

	public void stop() {
		th.stop();
	}
}